package me.yoqi.hadoop.test;

import java.io.IOException;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FSDataInputStream;
import org.apache.hadoop.fs.FSDataOutputStream;
import org.apache.hadoop.fs.FileStatus;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;

/**hadoop通用操作:新建文件/文件夹/读写文件等等
 * 
 * @author liuyuqi
 *
 */
public class CommonOperation {

	public static void main(String[] args) throws IOException {
		Path path = new Path("/user/root/test1");
		makeDir(path);
	}

	/**
	 * @param path
	 * @return
	 * @throws IOException
	 */
	public static boolean makeDir(Path path) throws IOException {
		Configuration conf = new Configuration();
		FileSystem fs = FileSystem.get(conf);// 有异常抛出
		boolean flag = fs.mkdirs(path);
		// fs.create(path);
		fs.close();
		return flag;
	}

	public boolean delDir(Path path) throws IOException {
		Configuration conf = new Configuration();
		FileSystem fs = FileSystem.get(conf);// 有异常抛出
		boolean flag = fs.delete(path);
		fs.close();
		return flag;
	}

	public void putFile() throws IOException {
		Configuration conf = new Configuration();
		FileSystem fs = FileSystem.get(conf);
		Path src = new Path("/home/hadoop/word.txt");
		Path dst = new Path("/user/hadoop/data/");
		fs.copyFromLocalFile(src, dst);
		fs.close();
	}

	public void delFile() throws IOException {
		Configuration conf = new Configuration();
		FileSystem fs = FileSystem.get(conf);

		Path path = new Path("/user/hadoop/data/word.txt");
		fs.delete(path);
		fs.close();
	}

	public void readFile() throws IOException {
		Configuration conf = new Configuration();
		FileSystem fs = FileSystem.get(conf);
		Path path = new Path("/user/hadoop/data/write.txt");
		if (fs.exists(path)) {
			FSDataInputStream is = fs.open(path);
			FileStatus status = fs.getFileStatus(path);
			byte[] buffer = new byte[Integer.parseInt(String.valueOf(status.getLen()))];
			is.readFully(0, buffer);
			is.close();
			fs.close();
			System.out.println(buffer.toString());
		}
	}

	public static void writeFile() throws IOException {
		Configuration conf = new Configuration();
		FileSystem fs = FileSystem.get(conf);
		Path path = new Path("/user/hadoop/data/write.txt");
		FSDataOutputStream out = fs.create(path);
		out.writeUTF("da jia hao,cai shi zhen de hao!");
		fs.close();
	}

}